/*
 * ADC.c
 *
 * Created on: 25.04.2011    Programmer: Andreas Ott
 * 
 */

#include "ADC.h"
#include <avr/io.h>	
#include <stdlib.h>

void ADC_Init (void)
{

	ADMUX = (0<<REFS1) | (1<<REFS0);					//Interne AVcc Referenz
	ADCSRA = (1<<ADPS0) | (1<<ADPS1) | (1<<ADPS2);		//Teilerverhltnis fr ADC Taktung auf 128 gestellt muss zwischen 50KHz...200KHz liegen.
	ADCSRA |= (1<<ADEN);								//ADC enable
	ADMUX |= (1<<MUX0);									//Inputport ADC1
	//Erste Wandlung um Einschwingvorgnge nichtig zu machen. Nach der Konvertierung wird das ADSC rckgesetzt.
	
	ADCSRA |= (1<<ADSC);								//Start Conversion
	while (ADCSRA & (1<<ADSC))							//Nach Conversion wird ADSC auf Low gesetzt
	{}
	return ADCW; 
	
}

int Calc_ADC (void)
{
	ADCSRA |= (1<<ADSC);								//Start Conversion
	while (ADCSRA & (1<<ADSC))							//Nach Conversion wird ADSC auf Low gesetzt
	{}
	return ADCW;
}
