   /*
 	* MAIN_USART_LED.c
 	*
 	* Created on: 25.04.2011    Programmer: Andreas Ott
 	* 
 	*/
	/*
	ber einen Poti soll eine LED gedimmt werden.

	Verwendeter C ist ein Atmega 644. 
	Es wird ein Atmel Evaluationboard V2.0 
	mit Addon V1.0 verwendet
	Die Daten werden per USB-->RS232 an die Software Putty bertragen und ausgegeben
	*/



#include "ADC.h"
#include "USART.h"
#include <avr/io.h>										// Fr Kommunikation ber Ports bentigt
#include <util/delay.h>									// Fr Wartezeiten bentigt
#include <stdlib.h>
#include <math.h>
#include <stdio.h>

#define F_CPU 16000000UL								//16 MHz Quarz



/////////////////////////In-, Output Initialisieren///////////////////////////////////////////////////
void InOutput_Init(void)
{
	DDRA = 0x00;										//Port A als Eingang deklarieren
	DDRD = 0xFF;										//Port D als Ausgang deklarieren
	
	PORTA=0b00000000;									//Port A alle Werte auf Null setzten
	PORTD=0b00000000;									//Port D alle Werte auf High setzten (negierte logig)
	
}
/////////////////////////LED Ausgabe////////////////////////////////////////////////////////////////////////////
void LED_calc (uint16_t adc_val)
{
if (adc_val <= 128)
	{
	PORTD = (1<<PA0);
	}
else if (adc_val >128 && adc_val <=256)
	{
	PORTD = (1<<PA1);
	}
else if (adc_val >256 && adc_val <=384)
	{
	PORTD = (1<<PA2);
	}
else if (adc_val >384 && adc_val <=512)
	{
	PORTD = (1<<PA3);
	}
else if (adc_val >512 && adc_val <=640)
	{
	PORTD = (1<<PA4);
	}
else if (adc_val >640 && adc_val <=768)
	{
	PORTD = (1<<PA5);
	}
else if (adc_val >768 && adc_val <=896)
	{
	PORTD = (1<<PA6);
	}
else if (adc_val >896 && adc_val <=1024)
	{
	PORTD = (1<<PA7);
	}
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int main (void)
{
	uint16_t t=0;
	

	InOutput_Init();
	ADC_Init ();
	USART_Init ();

	while (1)
	{
		uint16_t led_value = Calc_ADC();
		LED_calc (led_value);

		t=t+1;

		if (t==1000)
		{
			t=0;

			USART_Puti(led_value);
			//USART_Putc('d\n');
		}

	}
return (0);
}


