/*
 * USART.c
 *
 * Created on: 25.04.2011    Programmer: Andreas Ott
 * 
 */

#include "USART.h"
#include <avr/io.h>	
#include <stdlib.h>

/////////////////////////////USART initialisieren//////////////////////////////////////////////////////////////////////////////////////
void USART_Init (void)
{
	UCSR0B |= (1<<TXEN0);                           		// UART Transmitt einschalten
  	UCSR0C = (1<<UCSZ00)|(1 << UCSZ01);					// Asynchron 8Bit 1Stop kein Parity 
	UBRR0H = UBRR_VAL >> 8;
  	UBRR0L = UBRR_VAL & 0xFF;
	return ADCW;								
}

//////////////////////////////////////Sendet Daten von USART an Putty///////////////////////////////////////////////////////////////////
void USART_Puts (char *value_string)
{
	
	while (*value_string)
	{
		while (!(UCSR0A & (1<<UDRE0)))  /* warten bis Senden moeglich                   */
	    	{
 	   		}
 		
	    
		                    
		UDR0 = *value_string++;			/* schreibt den String x auf die Schnittstelle */
	}
}
////////////////////////////////////////////////////////////////////////////////////////////////
int USART_Putc(unsigned char c)
{
    while (!(UCSR0A & (1<<UDRE0)))  /* warten bis Senden moeglich */
    {
    }

    UDR0 = c;                      /* sende Zeichen */
    return 0;
}
////////////////////////////////////////////////////////////////////////////////////////////////
void USART_Putd( double x)
{
	   char s[5];
	   dtostrf( x, 5, 0, s );
	   USART_Puts( s );
}
////////////////////////////////////////////////////////////////////////////////////////////////
void USART_Puti( int x)
{
	   char s[3];
	   dtostrf( x, 3, 0, s );
	   USART_Puts( s );
}
